package com.xkrs.service;

import com.xkrs.model.vo.ApplicationProjectVo;

import java.util.List;

/**
 * @author XinYi Song
 */
public interface ResponsibleProjectService {

    /**
     * 负责人对项目的操作
     * @param responsibleProjectNumber
     * @param token
     * @return
     */
    String operateResponsible(String responsibleProjectNumber,String token);

    /**
     * 负责人对项目进行重新开始的操作
     * @param ProjectNumber
     * @param token
     * @return
     */
    String operateReStart(String ProjectNumber,String token);

    /**
     * 负责人对项目进行结束的操作
     * @param ProjectNumber
     * @param token
     * @return
     */
    String operateOver(String ProjectNumber,String token);

    /**
     * 查询负责人申请的信息
     * @param projectNumber
     * @return
     */
    ApplicationProjectVo selectApplicationInformation(String projectNumber);

    /**
     * 管理员对负责人进行允许的操作
     * @param projectNumber
     * @param userId
     * @return
     */
    void adminAllow(String projectNumber,Integer userId);

    /**
     * 管理员对负责人进行拒绝的操作
     * @param projectNumber
     * @param userId
     */
    void adminRefuse(String projectNumber,Integer userId);

    /**
     * 负责人移除成员
     * @param memberId
     * @param projectNumber
     */
    void removeMember(Integer memberId,String projectNumber);

    /**
     * 负责人移交权限
     * @param memberId
     * @param projectNumber
     * @param userId
     *
     */
    void transferPermissions(Integer memberId,String projectNumber,Integer userId);

    /**
     * 查询管理项目的编号
     * @param userId
     * @return
     */
    List<String> selectProjectNumberByPrincipalId(Integer userId);

    /**
     * 查询正在审核的项目的编号
     * @param userId
     * @return
     */
    List<String> selectProjectNumberByPrincipalIds(Integer userId);
}
